package swingmovinggrapheditor.gui;

import swingmovinggrapheditor.graph.LocatedGraph;
import swingmovinggrapheditor.graph.LocatedNode;
import java.awt.Color;
import java.awt.Graphics;
import java.io.Serializable;
import swingmovinggrapheditor.graph.Arc;

/**
 *
 * @author trust56
 */
public abstract class SwingGraph<T extends Serializable> extends LocatedGraph<T> implements Serializable{

    public void paint(Graphics g) {
        for (Arc<T, LocatedNode<T>> arc : arcs) {
            if (selectedArc == arc) {
                g.setColor(Color.ORANGE);
            } else {
                g.setColor(Color.BLACK);
            }
            int x1 = arc.edge1.x;
            int y1 = arc.edge1.y;
            if (arc.edge1 != arc.edge2) {
                int x2 = arc.edge2.x;
                int y2 = arc.edge2.y;
                g.drawLine(x1, y1, x2, y2);
            } else {
                g.drawOval(x1, y1, NODE_RADIUS * 2, NODE_RADIUS * 2);
            }
        }
        for (LocatedNode<T> swingNode : nodes) {
            int x = swingNode.x;
            int y = swingNode.y;
            if (selectedNode == swingNode) {
                g.setColor(Color.ORANGE);
            } else {
                g.setColor(Color.WHITE);
            }
            g.fillOval(x - NODE_RADIUS, y - NODE_RADIUS,
                    NODE_RADIUS * 2, NODE_RADIUS * 2);
            g.setColor(Color.BLACK);
            g.drawOval(x - NODE_RADIUS, y - NODE_RADIUS,
                    NODE_RADIUS * 2, NODE_RADIUS * 2);
            g.drawString(swingNode.element.toString(), x - 2, y + 4);
        }
    }
}
